OpenTTD Source: src/network/network_udp.cpp File Reference

OpenTTD Source 1.11.0-RC1

Data Structures | Functions | Variables
network_udp.cpp File Reference
`#include "../stdafx.h"`
`#include "../date_func.h"`
`#include "../map_func.h"`
`#include "../debug.h"`
`#include "network_gamelist.h"`
`#include "network_internal.h"`
`#include "network_udp.h"`
`#include "network.h"`
`#include "../core/endian_func.hpp"`
`#include "../company_base.h"`
`#include "../thread.h"`
`#include "../rev.h"`
`#include "../newgrf_text.h"`
`#include "../strings_func.h"`
`#include "table/strings.h"`
`#include <mutex>`
`#include "core/udp.h"`
`#include "../safeguards.h"`

Go to the source code of this file.

## Data Structures
class | MasterNetworkUDPSocketHandler
| ‍*** Communication with the masterserver ***‍/ More...
class | ServerNetworkUDPSocketHandler
| ‍*** Communication with clients (we are server) ***‍/ More...
class | ClientNetworkUDPSocketHandler
| ‍*** Communication with servers (we are client) ***‍/ More...

## Functions
static const std::chrono::minutes | ADVERTISE_NORMAL_INTERVAL (15)
| interval between advertising.
static const std::chrono::seconds | ADVERTISE_RETRY_INTERVAL (10)
| re-advertise when no response after this amount of time.
static void | DoNetworkUDPQueryServer (NetworkAddress &address, bool needs_mutex, bool manually)
| Helper function doing the actual work for querying the server. More...
void | NetworkUDPQueryServer (NetworkAddress address, bool manually)
| Query a specific server. More...
static void | NetworkUDPBroadCast (NetworkUDPSocketHandler *socket)
| Broadcast to all ips.
void | NetworkUDPQueryMasterServer ()
| Request the the server-list from the master server.
void | NetworkUDPSearchGame ()
| Find all servers.
static void | NetworkUDPRemoveAdvertiseThread ()
| Thread entry point for de-advertising.
void | NetworkUDPRemoveAdvertise (bool blocking)
| Remove our advertise from the master-server. More...
static void | NetworkUDPAdvertiseThread ()
| Thread entry point for advertising.
void | NetworkUDPAdvertise ()
| Register us to the master server This function checks if it needs to send an advertise. More...
void | NetworkUDPInitialize ()
| Initialize the whole UDP bit.
void | NetworkUDPClose ()
| Close all UDP related stuff.
void | NetworkBackgroundUDPLoop ()
| Receive the UDP packets.

## Variables
static std::mutex | _network_udp_mutex
| Mutex for all out threaded udp resolution and such.
static uint64 | _session_key = 0
| Session key to register ourselves to the master server.
static const uint32 | ADVERTISE_RETRY_TIMES = 3
| give up re-advertising after this much failed retries
NetworkUDPSocketHandler * | _udp_client_socket = nullptr
| udp client socket
NetworkUDPSocketHandler * | _udp_server_socket = nullptr
| udp server socket
NetworkUDPSocketHandler * | _udp_master_socket = nullptr
| udp master socket

## Detailed Description

This file handles the UDP related communication.

This is the GameServer <-> MasterServer and GameServer <-> GameClient communication before the game is being joined.

Definition in file network_udp.cpp.

## Function Documentation

## ◆ DoNetworkUDPQueryServer()

static void DoNetworkUDPQueryServer | ( | NetworkAddress & | address,
|  | bool | needs_mutex,
|  | bool | manually
| ) |  |
| static

Helper function doing the actual work for querying the server.

Parameters

  address | The address of the server.
  needs_mutex | Whether we need to acquire locks when sending the packet or not.
  manually | Whether the address was entered manually.

Definition at line 56 of file network_udp.cpp.

References _network_udp_mutex, _udp_client_socket, NetworkGameList::address, NetworkAddress::GetAddressAsString(), NetworkAddress::GetHostname(), NetworkGameInfo::hostname, NetworkGameList::info, lastof, lock, NetworkGameList::manually, NetworkGameListAddItemDelayed(), PACKET_UDP_CLIENT_FIND_SERVER, NetworkUDPSocketHandler::SendPacket(), NetworkGameInfo::server_name, and strecpy().

Referenced by NetworkUDPQueryServer().

## ◆ NetworkUDPAdvertise()

void NetworkUDPAdvertise | ( |  | ) |

Register us to the master server This function checks if it needs to send an advertise.

< The last time we performed an advertisement.

Definition at line 571 of file network_udp.cpp.

References _network_advertise_retries, _network_need_advertise, _network_server, _network_udp_server, _networking, _settings_client, ADVERTISE_NORMAL_INTERVAL(), ADVERTISE_RETRY_INTERVAL(), ADVERTISE_RETRY_TIMES, ClientSettings::network, NetworkUDPAdvertiseThread(), NetworkSettings::server_advertise, and StartNewThread().

## ◆ NetworkUDPQueryServer()

void NetworkUDPQueryServer | ( | NetworkAddress | address,
|  | bool | manually
| ) |  |

Query a specific server.

Parameters

  address | The address of the server.
  manually | Whether the address was entered manually.

Definition at line 78 of file network_udp.cpp.

References DoNetworkUDPQueryServer(), NetworkAddress::IsResolved(), and StartNewThread().

Referenced by NetworkGameListRequery().

## ◆ NetworkUDPRemoveAdvertise()

void NetworkUDPRemoveAdvertise | ( | bool | blocking | ) |

Remove our advertise from the master-server.

Parameters

  blocking | whether to wait until the removal has finished.

Definition at line 519 of file network_udp.cpp.

References _network_server, _network_udp_server, _networking, NetworkUDPRemoveAdvertiseThread(), and StartNewThread().

Referenced by NetworkDisconnect(), and MasterNetworkUDPSocketHandler::Receive_MASTER_ACK_REGISTER().